#!/bin/sh
# This program may be used, executed, copied, modified and distributed
# without royalty for the purpose of developing, using, marketing, or distributing.

# Setup
SAMP_DIR=`pwd`
WAS_DIR=`dirname ${0}`/../../../
cd ${WAS_DIR}
REPLACE_WAS_HOME=`pwd`   
cd bin
. ./setupCmdLine.sh
cd "${SAMP_DIR}"
THIN_JAR_FILE=com.ibm.jaxws.thinclient_7.0.0.jar
THIN_JAR=$WAS_HOME/runtimes/$THIN_JAR_FILE

#Platform specific args...
PLATFORM=`/bin/uname`
case $PLATFORM in
  OS/390)
    JAVA_LIB_PATH=-Djava.library.path=$WAS_HOME/lib
esac

# Verify the thinclient jar exists before we run
if [ -f $THIN_JAR ] 
  then
	CLASSPATH=$THIN_JAR:$WAS_HOME/samples/lib/JaxWSServicesSamples/WSSampleClientSei.jar
	$JAVA_HOME/bin/java $JAVA_LIB_PATH -cp "$CLASSPATH" com.ibm.was.wssample.sei.cli.SampleClient "$@"
  else
	echo "Jar file "$THIN_JAR_FILE" cannot be located."
	echo "This sample requires installation of 'Stand-alone thin clients'."
	echo "Please correct the installation options before running this sample."
  fi
exit 0
