#!/bin/sh

cd ../../../bin
. ./setupCmdLine.sh
cd $USER_INSTALL_ROOT/samples/src/PlantsByWebSphere

# ANT tools are specific to the zOS and OS400 platforms.
# Detect the platform and set the suffix.
# Use suffix to identify the bundle fragment where the ANT tools are located.
# Add the bundle fragment jar to the ANTCLASSPATH.
PLATFORM=`/bin/uname`
export PLATFORM
case $PLATFORM in
  OS400)
    XPLAT="os400" ;;
  OS/390)
    XPLAT="ws390" ;;
  *)
    XPLAT="dist" ;;
esac

ANTCLASSPATH="$JAVA_HOME/lib/tools.jar:$WAS_HOME/plugins/com.ibm.ws.runtime.jar:$WAS_HOME/plugins/com.ibm.ws.runtime."$XPLAT".jar:$CLASSPATH"

# Additional jars needed by PlantsByWebSphere Sample
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/lib/j2ee.jar:$WAS_HOME/plugins/com.ibm.ws.emf.jar:$WAS_HOME/plugins/com.ibm.ws.wccm.jar:$WAS_HOME/lib/bootstrap.jar:$WAS_HOME/plugins/com.ibm.ws.bootstrap.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/plugins/org.eclipse.emf.ecore.jar:$WAS_HOME/plugins/org.eclipse.emf.common.jar:$WAS_HOME/plugins/org.eclipse.emf.ecore.xmi.jar:$WAS_HOME/plugins/org.eclipse.equinox.common_.jar:$WAS_HOME/plugins/org.eclipse.equinox.registry.jar:$WAS_HOME/plugins/org.eclipse.core.runtime_.jar:$WAS_HOME/plugins/org.eclipse.osgi_.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/plugins/com.ibm.wsfp.main.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/plugins/com.ibm.ffdc.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/plugins/com.ibm.ws.prereq.commons-logging.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/lib/commons-discovery.jar"
ANTCLASSPATH="$ANTCLASSPATH:$WAS_HOME/plugins/com.ibm.ws.prereq.wsdl4j.jar"
   
# Additional classpath elements needed by PlantsByWebSphere Sample.
ANTCLASSPATH=$ANTCLASSPATH:"$USER_INSTALL_ROOT/samples/bld/PlantsByWebSphere"

# Ant requires classpath elements to exist before beginning...
mkdir -p "$USER_INSTALL_ROOT/samples/bld/PlantsByWebSphere"

export ANTCLASSPATH

"$JAVA_HOME/jre/bin/java" -classpath $ANTCLASSPATH org.apache.tools.ant.Main -Dbasedir="$USER_INSTALL_ROOT/samples" -Dwas_home="$WAS_HOME" $@
