/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Axis" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

//
// "This program may be used, executed, copied, modified and distributed without 
// royalty for the purpose of developing, using, marketing, or distributing."
//
/*
 * Classname: AddressBookBeanImpl.java
 * 
 */

package com.ibm.websphere.samples.webservices.addr;

import java.util.Hashtable;
import java.util.Map;
import java.rmi.RemoteException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.EJBObject;
import javax.ejb.CreateException;

public class AddressBookBeanImpl implements SessionBean {
    private static final long serialVersionUID = 3139362106123493799L;
    private SessionContext mySessionCtx;
    private Map addresses = new Hashtable();

    /**
     * Construct a new AddressBookBeanImpl entry for the bottom up EJB.
     * It's members are hardcoded to some standard
     * values, except streetNum is 2.
     *
     */

    public AddressBookBeanImpl()
    {
        mySessionCtx = null;

	// populate the AddressBook
	Address myAddress = new Address();
	String name = "Purdue Boilermaker";
	Phone phoneNumber = new Phone();
	myAddress.setStreetNum(2);
	myAddress.setStreetName("University Drive");
	myAddress.setCity("West Lafayette");
	myAddress.setState(StateType.IN);
	myAddress.setZip(47907);
	phoneNumber.setAreaCode(765);
	phoneNumber.setExchange("555");
	phoneNumber.setNumber("4900");
	myAddress.setPhoneNumber(phoneNumber);
	addresses.put("Purdue Boilermaker", myAddress);
    }

    public void ejbActivate()
    throws RemoteException
    {
    }

    public void ejbCreate()
    throws CreateException
    {
    }

    public void ejbPassivate()
    throws RemoteException
    {
    }

    public void ejbRemove()
    throws RemoteException
    {
    }
    public SessionContext getSessionContext()
    {
        return mySessionCtx;
    }

    public void setSessionContext(SessionContext sessioncontext)
    	throws RemoteException
    {
        mySessionCtx = sessioncontext;
    }

    /**
     * Retrieve an entry from the AddressBook.
     * 
     *@param name the name of the entry to look up.
     *@return the AddressBook entry matching name or null if none.
     */

    public Address getAddressFromName(java.lang.String name) 
    {
        return(Address) this.addresses.get(name);
    }
}
